#ifndef _HLBR_DECODE_ETHERNET_H_
#define _HLBR_DECODE_ETHERNET_H_

#include "../config.h"
#include "../engine/hlbr.h"
#include "decode.h"

#define ETHERNET_TYPE_IP	0x0800
#define ETHERNET_TYPE_ARP	0x0806
#define ETHERNET_TYPE_VLAN	0x8100

typedef struct ethernet_header{
	unsigned char	DstMac[6];
	unsigned char	SrcMac[6];
	unsigned short	Type;
} EtherHdr;

typedef struct ethernet_data{
	EtherHdr*		Header;
} EthernetData;

typedef struct ethernet_vlan_header{
#ifdef HLBR_LITTLE_ENDIAN
	unsigned char	ID0:4;
	unsigned char	CFI:1;
	unsigned char	Priority:3;
#else
	unsigned char	Priority:3;
	unsigned char	CFI:1;
	unsigned char	ID0:4;
#endif
	unsigned char	ID1;
	unsigned short	Type;
} EtherVlanHdr;

typedef struct ethernet_vlan_data{
	EtherHdr*		Header;
	EtherVlanHdr*		VlanHeader;
} EthernetVlanData;

int InitDecoderEthernet();

#endif
