#ifndef _HLBR_DECODE_RTP_H_
#define _HLBR_DECODE_RTP_H_

#include "../config.h"
#include "../engine/hlbr.h"
#include "decode.h"

#define MAX_RTP_DATA_LEN 1024

//typedef struct rtp_data {
//	unsigned char	Message[MAX_RTP_DATA_LEN];
//} RTPData;

typedef struct rtp_header {
#ifdef HLBR_LITTLE_ENDIAN
	unsigned short cc:4,    	/* CSRC count */
		x:1,   				    /* header extension flag */
		p:1,					/* padding flag */
		version:2,				/* protocol version */
		pt:7,					/* payload type */
		m:1;					/* marker bit */
#else
	unsigned short version:2,	/* protocol version */
		p:1,					/* padding flag */
		x:1,   				    /* header extension flag */
		cc:4, 				   	/* CSRC count */
		m:1,					/* marker bit */
		pt:7;					/* payload type */
#endif	
	unsigned short seq;			/* sequence number */
	unsigned int timestamp;		/* timestamp */
	unsigned int ssrc;			/* synchronization source */
//	unsigned int csrc[1];		/* optional CSRC list */
} RTPHdr;

typedef struct rtp_data{
	RTPHdr*		Header;
} RTPData;

int InitDecoderRTP();
int RTPHeaderVerification(RTPData* data);

#endif

