#include "decode_sip_rtp.h"
#include "../packets/packet.h"
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <osipparser2/osip_parser.h>

//#define DEBUG
//#define DEBUGPATH
//#define DEBUGPACKET

extern GlobalVars	Globals;

int	SIPRTPDecoderID;

/***************************************
* Apply the sip decoding
****************************************/
void* DecodeSIPRTP(int PacketSlot){
	PacketRec*			p;
	osip_message_t*		data;
	RTPData*			dataRTP;
	int					i;
	char*				media;
	char*				port;
	
#ifdef DEBUGPATH
	printf("In DecodeSIPRTP\n");
#endif

#ifdef DEBUG
	printf("Decoding SIP RTP Header\n");
#endif

	p=&Globals.Packets[PacketSlot];


	/*get the sip method of the packet*/
	data=SIPParser2((char*)(p->RawPacket+p->BeginData),data);
	if (data==NULL){	
		osip_message_free(data);
		dataRTP=malloc(sizeof(RTPData));
		dataRTP->Header=(RTPHdr*)(p->RawPacket+p->BeginData);
		if (!RTPHeaderVerification(dataRTP)) {
			free(dataRTP);
#ifdef DEBUG
			printf("Failed to parse SIP RTP Message\n");
#endif
			return FALSE;
		} else {
#ifdef DEBUG
			printf("RTP PACKET\n");
#endif
			return dataRTP;
		}
	} else {
#ifdef DEBUG
		printf("SIP PACKET\n");
#endif
		return data;
	}
}

/*************************************
* Set up the decoder
*************************************/
int InitDecoderSIPRTP(){
	int DecoderID;

#ifdef DEBUGPATH
	printf("In InitDecoderSIPRTP\n");
#endif
	
	if ((DecoderID=CreateDecoder("SIPRTP"))==DECODER_NONE){
#ifdef DEBUG
		printf("Couldn't Allocate SIP RTP Decoder\n");
#endif	
		return FALSE;
	}
	
	Globals.Decoders[DecoderID].DecodeFunc=DecodeSIPRTP;
	if (!DecoderAddDecoder(GetDecoderByName("IP"), DecoderID)){
		printf("Failed to Bind SIP RTP Decoder to IP Decoder\n");
		return FALSE;
	}

	SIPRTPDecoderID=GetDecoderByName("SIPRTP");

	return TRUE;
}
